<template>
    <div class="container my-cart">
        <div class="row justify-content-center pt-3">
            <div class="col-md-8 list-product-cart">
                <div class="py-2">
                    <a class="py-2" href="/">
                        <i class="fa-solid fa-chevron-left"></i>
                        <span class="fw-light fs-5"> Tiếp tục mua hàng</span>
                    </a>
                </div>
                <div class="fs-3 py-2 fw-normal">Có {{ arrCart.length }} sản phẩm trong giỏ hàng</div>
                <template v-for="(cart,index) in arrCart" :key="index">
                    <div class="card mt-3">
                        <div class="d-flex">
                            <div class="form-check d-flex align-items-center ms-3">
                                <input v-on:click="checked($event,index)" class="form-check-input" type="checkbox" :disabled="cart.products.quantity == 0">
                            </div>
                            <div class="p-3 pe-0">
                                <img :src="cart.products.thumbnail" width="100" height="100" alt="">
                            </div>
                            <div class="w-100">
                                <div class="p-2 d-flex justify-content-between w-100">
                                    <div class="product-name">
                                        <span class="fs-3 fw-600">
                                            {{ cart.products.name }}
                                        </span>
                                    </div>
                                    <div class="icon-delete p-1">
                                        <a href="javascript:void(0)" v-on:click="deleteCart(cart.id, index)">
                                            <i class="fa-solid fa-trash-can"></i>
                                        </a>
                                    </div>
                                </div>
                                <div class="d-flex justify-content-between px-3">
                                    <div>
                                        <div class="fs-5">Số lượng</div>
                                        <div v-if="cart.products.quantity > 0" class="input-group">
                                            <button 
                                                v-on:click="decrement(index)" 
                                                class="btn btn-outline-secondary" 
                                                type="button" id="button-addon1">
                                            -</button>
                                            <input @input="changeQuantity(index)" v-model.number="cart.quantity" class="form-control">
                                            <button 
                                                v-on:click="increment(index)" 
                                                class="btn btn-outline-secondary" 
                                                type="button" id="button-addon1">
                                            +</button>
                                        </div>
                                        <div v-else class="text-danger fs-4">
                                            Hết hàng
                                        </div>
                                    </div>
                                    <div class="product-price text-end">
                                        <div class="price fs-3" v-if="cart.products.sale > 0">{{ new Intl.NumberFormat().format((cart.products.price * (100-cart.products.sale) / 100 ) * cart.quantity) }}đ</div>
                                        <div class="fs-5" :class="{'sale' : cart.products.sale > 0}">{{ new Intl.NumberFormat().format(cart.products.price * cart.quantity ) }}đ</div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="pay-online">
                            <span>Khuyến mại thanh toán</span>
                            <div class="sale-pay">Giảm ngay 5% tối đa 100.000 đồng khi thanh toán online</div>
                        </div>
                    </div>
                </template>
            </div>
            <div class="cnt-money">
                <div class="row w-100 justify-content-center">
                    <div class="col-md-6">
                        <div class="confirm-condition-pay">
                            <input v-model="confirm" class="form-check-input mt-0 mx-2" type="checkbox" id="confirmOrder">
                            <label for="confirmOrder">Tôi đồng ý với Điều khoản dịch vụ, Chính sách thu thập và xử lý dữ liệu cá nhân của Shop.</label>
                        </div>
                        <hr>
                        <div class="total-payment-temporary row">
                            <div class="col-md-6 money">
                                <div class="d-flex justify-content-between">
                                    <span>Tổng tiền:</span>
                                    <span>{{ new Intl.NumberFormat().format(total) }}đ</span>
                                </div>
                                <div class="d-flex justify-content-between">
                                    <span>Giảm giá khuyến mãi:</span>
                                    <span>{{ new Intl.NumberFormat().format(totalSale) }}đ</span>
                                </div>
                                <div class="d-flex justify-content-between">
                                    <span>Giảm giá voucher:</span>
                                    <span>{{ new Intl.NumberFormat().format(totalVoucher) }}đ</span>
                                </div>
                            </div>
                            <div class="col-md-6 money">
                                <div class="d-flex justify-content-between">
                                    <span>Thanh toán:</span>
                                    <span>{{ Intl.NumberFormat().format(totalPay) }}đ</span>
                                </div>
                                <button :disabled="totalPay === 0 || !confirm" v-on:click="checkout()" class="btn btn-danger w-100 p-2 m-2">Đặt hàng</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="position-fixed bottom-0 start-0 p-3" style="z-index: 11111">
        <div data-delay="4000" ref="el" id="liveToast" class="toast hide bg-danger" role="alert" aria-live="assertive" aria-atomic="true">
            <div class="toast-header pb-2">
                <strong class="me-auto">Thông báo mới</strong>
                <small>Bây giờ</small>
                <button type="button" class="btn-close" data-bs-dismiss="toast" aria-label="Close"></button>
            </div>
            <div class="toast-body pt-2">
                {{ message }}
            </div>
        </div>
    </div>
</template>

<script>
const { Toast } = bootstrap
    export default {
        name: 'cart',
        data(){
            return {
                arrCart: {},
                totalPay: 0,
                totalVoucher: 0,
                total: 0,
                totalSale: 0,
                confirm: false,
                message: ''
            }
        },
        props:{
            carts: {
                type: Object,
                required: true
            },
        },
        methods:{
            decrement(index){
                if(this.arrCart[index].quantity === 1) {
                    return;
                }
                this.arrCart[index].quantity = this.arrCart[index].quantity -1;
                this.calculateCart();
            },
            increment(index){
                if(this.arrCart[index].quantity === this.arrCart[index].products.quantity) {
                    return;
                }
                this.arrCart[index].quantity = this.arrCart[index].quantity + 1;
                this.calculateCart();
            },
            checked($event, index) {
                this.arrCart[index].check = $event.target.checked;
                this.calculateCart();
            },
            changeQuantity(index) {
                if(this.arrCart[index].quantity === 0) {
                    this.arrCart[index].quantity = 1;
                }
                if(this.arrCart[index].quantity > this.arrCart[index].products.quantity) {
                    this.arrCart[index].quantity = this.arrCart[index].products.quantity;
                }
                this.calculateCart();
            },
            calculateCart(){
                this.total = this.totalPay = this.totalSale = this.totalVoucher = 0;
                this.arrCart.map((item) => {
                    if(item.check) {

                        //Tổng tiền
                        this.total += (item.quantity * item.products.price);

                        //tính tiền được giảm giá
                        if(item.products.sale > 0) {
                            let priceSale = item.products.price * item.products.sale / 100;
                            this.totalSale += (priceSale*item.quantity)
                        }
                    }
                });

                //Tổng tiền phải thanh toán
                this.totalPay = this.total - this.totalSale - this.totalVoucher;
            },
            deleteCart(id, index){
                let data = {
                    id: id
                }
                this.$store.dispatch('deleteCart', data).then(res => {
                    console.log(res);
                    if(res.status === 200) {
                        this.arrCart.splice(index, 1);
                    }
                });
            },
            checkout(){
                let data = this.arrCart.filter((item) =>item.check);
                this.$store.dispatch('postOrder', {data: JSON.stringify(data)}).then(res => {
                    if(res.status === 400) {
                        this.message = "Số lượng sản phẩm không đúng!"
                        this.showToast();
                    }
                });
            },
            showToast(){
                var toast = new Toast(this.$refs.el)
                toast.show();
            },
        },
        mounted() {
            this.arrCart = this.carts;
        }
    }
</script>
<style lang="scss">
.my-cart {
    .total-payment-temporary {
        .money {
            font-size: 18px;
        }
    }
    .list-product-cart {
        padding-bottom: 210px;
    }
    .cnt-money {
        padding: 30px;
        position: fixed;
        width: 100%;
        bottom: 0px;
        background-color: #ffffff;
        border-top: 1px solid #e4e8ed;
        display: flex;
        z-index: 100;
        filter: drop-shadow(rgba(2, 11, 39, 0.08) 0px -4px 16px);
    }
    color: #020b27;
    .fw-600 {
        font-weight: 600;
    }
    .relative {
        position: relative;
    }
    .absolute {
        position: absolute;
    }
    .form-check-input {
        width: 1.5em;
        height: 1.5em;
    }
    .btn-outline-secondary {
        height: 30px;
        display: flex;
        align-items: center;
        border: 1px solid #d9dee3;
    }
    .form-control {
        height: 30px;
        text-align: center;
    }
    .input-group {
        width: 170px;
    }
}
.pay-online {
    margin: 15px;
    .sale-pay {
        padding: 15px;
        border: 1px solid #e4e8ed;
        border-radius: 5px;
    }
}
</style>